"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_json1_0UpdateScheduledQueryCommand = exports.deserializeAws_json1_0UntagResourceCommand = exports.deserializeAws_json1_0TagResourceCommand = exports.deserializeAws_json1_0QueryCommand = exports.deserializeAws_json1_0PrepareQueryCommand = exports.deserializeAws_json1_0ListTagsForResourceCommand = exports.deserializeAws_json1_0ListScheduledQueriesCommand = exports.deserializeAws_json1_0ExecuteScheduledQueryCommand = exports.deserializeAws_json1_0DescribeScheduledQueryCommand = exports.deserializeAws_json1_0DescribeEndpointsCommand = exports.deserializeAws_json1_0DeleteScheduledQueryCommand = exports.deserializeAws_json1_0CreateScheduledQueryCommand = exports.deserializeAws_json1_0CancelQueryCommand = exports.serializeAws_json1_0UpdateScheduledQueryCommand = exports.serializeAws_json1_0UntagResourceCommand = exports.serializeAws_json1_0TagResourceCommand = exports.serializeAws_json1_0QueryCommand = exports.serializeAws_json1_0PrepareQueryCommand = exports.serializeAws_json1_0ListTagsForResourceCommand = exports.serializeAws_json1_0ListScheduledQueriesCommand = exports.serializeAws_json1_0ExecuteScheduledQueryCommand = exports.serializeAws_json1_0DescribeScheduledQueryCommand = exports.serializeAws_json1_0DescribeEndpointsCommand = exports.serializeAws_json1_0DeleteScheduledQueryCommand = exports.serializeAws_json1_0CreateScheduledQueryCommand = exports.serializeAws_json1_0CancelQueryCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const uuid_1 = require("uuid");
const models_0_1 = require("../models/models_0");
const TimestreamQueryServiceException_1 = require("../models/TimestreamQueryServiceException");
const serializeAws_json1_0CancelQueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.CancelQuery",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0CancelQueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0CancelQueryCommand = serializeAws_json1_0CancelQueryCommand;
const serializeAws_json1_0CreateScheduledQueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.CreateScheduledQuery",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0CreateScheduledQueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0CreateScheduledQueryCommand = serializeAws_json1_0CreateScheduledQueryCommand;
const serializeAws_json1_0DeleteScheduledQueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.DeleteScheduledQuery",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0DeleteScheduledQueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0DeleteScheduledQueryCommand = serializeAws_json1_0DeleteScheduledQueryCommand;
const serializeAws_json1_0DescribeEndpointsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.DescribeEndpoints",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0DescribeEndpointsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0DescribeEndpointsCommand = serializeAws_json1_0DescribeEndpointsCommand;
const serializeAws_json1_0DescribeScheduledQueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.DescribeScheduledQuery",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0DescribeScheduledQueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0DescribeScheduledQueryCommand = serializeAws_json1_0DescribeScheduledQueryCommand;
const serializeAws_json1_0ExecuteScheduledQueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.ExecuteScheduledQuery",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0ExecuteScheduledQueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0ExecuteScheduledQueryCommand = serializeAws_json1_0ExecuteScheduledQueryCommand;
const serializeAws_json1_0ListScheduledQueriesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.ListScheduledQueries",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0ListScheduledQueriesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0ListScheduledQueriesCommand = serializeAws_json1_0ListScheduledQueriesCommand;
const serializeAws_json1_0ListTagsForResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.ListTagsForResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0ListTagsForResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0ListTagsForResourceCommand = serializeAws_json1_0ListTagsForResourceCommand;
const serializeAws_json1_0PrepareQueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.PrepareQuery",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0PrepareQueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0PrepareQueryCommand = serializeAws_json1_0PrepareQueryCommand;
const serializeAws_json1_0QueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.Query",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0QueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0QueryCommand = serializeAws_json1_0QueryCommand;
const serializeAws_json1_0TagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.TagResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0TagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0TagResourceCommand = serializeAws_json1_0TagResourceCommand;
const serializeAws_json1_0UntagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.UntagResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0UntagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0UntagResourceCommand = serializeAws_json1_0UntagResourceCommand;
const serializeAws_json1_0UpdateScheduledQueryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.0",
        "x-amz-target": "Timestream_20181101.UpdateScheduledQuery",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_0UpdateScheduledQueryRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
exports.serializeAws_json1_0UpdateScheduledQueryCommand = serializeAws_json1_0UpdateScheduledQueryCommand;
const deserializeAws_json1_0CancelQueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0CancelQueryCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0CancelQueryResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0CancelQueryCommand = deserializeAws_json1_0CancelQueryCommand;
const deserializeAws_json1_0CancelQueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0CreateScheduledQueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0CreateScheduledQueryCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0CreateScheduledQueryResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0CreateScheduledQueryCommand = deserializeAws_json1_0CreateScheduledQueryCommand;
const deserializeAws_json1_0CreateScheduledQueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.timestreamquery#ConflictException":
            throw await deserializeAws_json1_0ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.timestreamquery#ServiceQuotaExceededException":
            throw await deserializeAws_json1_0ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0DeleteScheduledQueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0DeleteScheduledQueryCommandError(output, context);
    }
    await collectBody(output.body, context);
    const response = {
        $metadata: deserializeMetadata(output),
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0DeleteScheduledQueryCommand = deserializeAws_json1_0DeleteScheduledQueryCommand;
const deserializeAws_json1_0DeleteScheduledQueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.timestreamquery#ResourceNotFoundException":
            throw await deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0DescribeEndpointsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0DescribeEndpointsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0DescribeEndpointsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0DescribeEndpointsCommand = deserializeAws_json1_0DescribeEndpointsCommand;
const deserializeAws_json1_0DescribeEndpointsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0DescribeScheduledQueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0DescribeScheduledQueryCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0DescribeScheduledQueryResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0DescribeScheduledQueryCommand = deserializeAws_json1_0DescribeScheduledQueryCommand;
const deserializeAws_json1_0DescribeScheduledQueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.timestreamquery#ResourceNotFoundException":
            throw await deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0ExecuteScheduledQueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0ExecuteScheduledQueryCommandError(output, context);
    }
    await collectBody(output.body, context);
    const response = {
        $metadata: deserializeMetadata(output),
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0ExecuteScheduledQueryCommand = deserializeAws_json1_0ExecuteScheduledQueryCommand;
const deserializeAws_json1_0ExecuteScheduledQueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.timestreamquery#ResourceNotFoundException":
            throw await deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0ListScheduledQueriesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0ListScheduledQueriesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0ListScheduledQueriesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0ListScheduledQueriesCommand = deserializeAws_json1_0ListScheduledQueriesCommand;
const deserializeAws_json1_0ListScheduledQueriesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0ListTagsForResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0ListTagsForResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0ListTagsForResourceCommand = deserializeAws_json1_0ListTagsForResourceCommand;
const deserializeAws_json1_0ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.timestreamquery#ResourceNotFoundException":
            throw await deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0PrepareQueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0PrepareQueryCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0PrepareQueryResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0PrepareQueryCommand = deserializeAws_json1_0PrepareQueryCommand;
const deserializeAws_json1_0PrepareQueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0QueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0QueryCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0QueryResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0QueryCommand = deserializeAws_json1_0QueryCommand;
const deserializeAws_json1_0QueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.timestreamquery#ConflictException":
            throw await deserializeAws_json1_0ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "QueryExecutionException":
        case "com.amazonaws.timestreamquery#QueryExecutionException":
            throw await deserializeAws_json1_0QueryExecutionExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0TagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0TagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0TagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0TagResourceCommand = deserializeAws_json1_0TagResourceCommand;
const deserializeAws_json1_0TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.timestreamquery#ResourceNotFoundException":
            throw await deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.timestreamquery#ServiceQuotaExceededException":
            throw await deserializeAws_json1_0ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0UntagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0UntagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_0UntagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0UntagResourceCommand = deserializeAws_json1_0UntagResourceCommand;
const deserializeAws_json1_0UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.timestreamquery#ResourceNotFoundException":
            throw await deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0UpdateScheduledQueryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_0UpdateScheduledQueryCommandError(output, context);
    }
    await collectBody(output.body, context);
    const response = {
        $metadata: deserializeMetadata(output),
    };
    return Promise.resolve(response);
};
exports.deserializeAws_json1_0UpdateScheduledQueryCommand = deserializeAws_json1_0UpdateScheduledQueryCommand;
const deserializeAws_json1_0UpdateScheduledQueryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.timestreamquery#AccessDeniedException":
            throw await deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.timestreamquery#InternalServerException":
            throw await deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidEndpointException":
        case "com.amazonaws.timestreamquery#InvalidEndpointException":
            throw await deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.timestreamquery#ResourceNotFoundException":
            throw await deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.timestreamquery#ThrottlingException":
            throw await deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.timestreamquery#ValidationException":
            throw await deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new TimestreamQueryServiceException_1.TimestreamQueryServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_json1_0AccessDeniedExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0AccessDeniedException(body, context);
    const exception = new models_0_1.AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0ConflictExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0ConflictException(body, context);
    const exception = new models_0_1.ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0InternalServerExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0InternalServerException(body, context);
    const exception = new models_0_1.InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0InvalidEndpointExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0InvalidEndpointException(body, context);
    const exception = new models_0_1.InvalidEndpointException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0QueryExecutionExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0QueryExecutionException(body, context);
    const exception = new models_0_1.QueryExecutionException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0ResourceNotFoundExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0ResourceNotFoundException(body, context);
    const exception = new models_0_1.ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0ServiceQuotaExceededExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0ServiceQuotaExceededException(body, context);
    const exception = new models_0_1.ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0ThrottlingExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0ThrottlingException(body, context);
    const exception = new models_0_1.ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const deserializeAws_json1_0ValidationExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_0ValidationException(body, context);
    const exception = new models_0_1.ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, body);
};
const serializeAws_json1_0CancelQueryRequest = (input, context) => {
    return {
        ...(input.QueryId !== undefined && input.QueryId !== null && { QueryId: input.QueryId }),
    };
};
const serializeAws_json1_0CreateScheduledQueryRequest = (input, context) => {
    var _a;
    return {
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.ErrorReportConfiguration !== undefined &&
            input.ErrorReportConfiguration !== null && {
            ErrorReportConfiguration: serializeAws_json1_0ErrorReportConfiguration(input.ErrorReportConfiguration, context),
        }),
        ...(input.KmsKeyId !== undefined && input.KmsKeyId !== null && { KmsKeyId: input.KmsKeyId }),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.NotificationConfiguration !== undefined &&
            input.NotificationConfiguration !== null && {
            NotificationConfiguration: serializeAws_json1_0NotificationConfiguration(input.NotificationConfiguration, context),
        }),
        ...(input.QueryString !== undefined && input.QueryString !== null && { QueryString: input.QueryString }),
        ...(input.ScheduleConfiguration !== undefined &&
            input.ScheduleConfiguration !== null && {
            ScheduleConfiguration: serializeAws_json1_0ScheduleConfiguration(input.ScheduleConfiguration, context),
        }),
        ...(input.ScheduledQueryExecutionRoleArn !== undefined &&
            input.ScheduledQueryExecutionRoleArn !== null && {
            ScheduledQueryExecutionRoleArn: input.ScheduledQueryExecutionRoleArn,
        }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_0TagList(input.Tags, context) }),
        ...(input.TargetConfiguration !== undefined &&
            input.TargetConfiguration !== null && {
            TargetConfiguration: serializeAws_json1_0TargetConfiguration(input.TargetConfiguration, context),
        }),
    };
};
const serializeAws_json1_0DeleteScheduledQueryRequest = (input, context) => {
    return {
        ...(input.ScheduledQueryArn !== undefined &&
            input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn }),
    };
};
const serializeAws_json1_0DescribeEndpointsRequest = (input, context) => {
    return {};
};
const serializeAws_json1_0DescribeScheduledQueryRequest = (input, context) => {
    return {
        ...(input.ScheduledQueryArn !== undefined &&
            input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn }),
    };
};
const serializeAws_json1_0DimensionMapping = (input, context) => {
    return {
        ...(input.DimensionValueType !== undefined &&
            input.DimensionValueType !== null && { DimensionValueType: input.DimensionValueType }),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
    };
};
const serializeAws_json1_0DimensionMappingList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0DimensionMapping(entry, context);
    });
};
const serializeAws_json1_0ErrorReportConfiguration = (input, context) => {
    return {
        ...(input.S3Configuration !== undefined &&
            input.S3Configuration !== null && {
            S3Configuration: serializeAws_json1_0S3Configuration(input.S3Configuration, context),
        }),
    };
};
const serializeAws_json1_0ExecuteScheduledQueryRequest = (input, context) => {
    var _a;
    return {
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.InvocationTime !== undefined &&
            input.InvocationTime !== null && { InvocationTime: Math.round(input.InvocationTime.getTime() / 1000) }),
        ...(input.ScheduledQueryArn !== undefined &&
            input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn }),
    };
};
const serializeAws_json1_0ListScheduledQueriesRequest = (input, context) => {
    return {
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
    };
};
const serializeAws_json1_0ListTagsForResourceRequest = (input, context) => {
    return {
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.ResourceARN !== undefined && input.ResourceARN !== null && { ResourceARN: input.ResourceARN }),
    };
};
const serializeAws_json1_0MixedMeasureMapping = (input, context) => {
    return {
        ...(input.MeasureName !== undefined && input.MeasureName !== null && { MeasureName: input.MeasureName }),
        ...(input.MeasureValueType !== undefined &&
            input.MeasureValueType !== null && { MeasureValueType: input.MeasureValueType }),
        ...(input.MultiMeasureAttributeMappings !== undefined &&
            input.MultiMeasureAttributeMappings !== null && {
            MultiMeasureAttributeMappings: serializeAws_json1_0MultiMeasureAttributeMappingList(input.MultiMeasureAttributeMappings, context),
        }),
        ...(input.SourceColumn !== undefined && input.SourceColumn !== null && { SourceColumn: input.SourceColumn }),
        ...(input.TargetMeasureName !== undefined &&
            input.TargetMeasureName !== null && { TargetMeasureName: input.TargetMeasureName }),
    };
};
const serializeAws_json1_0MixedMeasureMappingList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0MixedMeasureMapping(entry, context);
    });
};
const serializeAws_json1_0MultiMeasureAttributeMapping = (input, context) => {
    return {
        ...(input.MeasureValueType !== undefined &&
            input.MeasureValueType !== null && { MeasureValueType: input.MeasureValueType }),
        ...(input.SourceColumn !== undefined && input.SourceColumn !== null && { SourceColumn: input.SourceColumn }),
        ...(input.TargetMultiMeasureAttributeName !== undefined &&
            input.TargetMultiMeasureAttributeName !== null && {
            TargetMultiMeasureAttributeName: input.TargetMultiMeasureAttributeName,
        }),
    };
};
const serializeAws_json1_0MultiMeasureAttributeMappingList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0MultiMeasureAttributeMapping(entry, context);
    });
};
const serializeAws_json1_0MultiMeasureMappings = (input, context) => {
    return {
        ...(input.MultiMeasureAttributeMappings !== undefined &&
            input.MultiMeasureAttributeMappings !== null && {
            MultiMeasureAttributeMappings: serializeAws_json1_0MultiMeasureAttributeMappingList(input.MultiMeasureAttributeMappings, context),
        }),
        ...(input.TargetMultiMeasureName !== undefined &&
            input.TargetMultiMeasureName !== null && { TargetMultiMeasureName: input.TargetMultiMeasureName }),
    };
};
const serializeAws_json1_0NotificationConfiguration = (input, context) => {
    return {
        ...(input.SnsConfiguration !== undefined &&
            input.SnsConfiguration !== null && {
            SnsConfiguration: serializeAws_json1_0SnsConfiguration(input.SnsConfiguration, context),
        }),
    };
};
const serializeAws_json1_0PrepareQueryRequest = (input, context) => {
    return {
        ...(input.QueryString !== undefined && input.QueryString !== null && { QueryString: input.QueryString }),
        ...(input.ValidateOnly !== undefined && input.ValidateOnly !== null && { ValidateOnly: input.ValidateOnly }),
    };
};
const serializeAws_json1_0QueryRequest = (input, context) => {
    var _a;
    return {
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.MaxRows !== undefined && input.MaxRows !== null && { MaxRows: input.MaxRows }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.QueryString !== undefined && input.QueryString !== null && { QueryString: input.QueryString }),
    };
};
const serializeAws_json1_0S3Configuration = (input, context) => {
    return {
        ...(input.BucketName !== undefined && input.BucketName !== null && { BucketName: input.BucketName }),
        ...(input.EncryptionOption !== undefined &&
            input.EncryptionOption !== null && { EncryptionOption: input.EncryptionOption }),
        ...(input.ObjectKeyPrefix !== undefined &&
            input.ObjectKeyPrefix !== null && { ObjectKeyPrefix: input.ObjectKeyPrefix }),
    };
};
const serializeAws_json1_0ScheduleConfiguration = (input, context) => {
    return {
        ...(input.ScheduleExpression !== undefined &&
            input.ScheduleExpression !== null && { ScheduleExpression: input.ScheduleExpression }),
    };
};
const serializeAws_json1_0SnsConfiguration = (input, context) => {
    return {
        ...(input.TopicArn !== undefined && input.TopicArn !== null && { TopicArn: input.TopicArn }),
    };
};
const serializeAws_json1_0Tag = (input, context) => {
    return {
        ...(input.Key !== undefined && input.Key !== null && { Key: input.Key }),
        ...(input.Value !== undefined && input.Value !== null && { Value: input.Value }),
    };
};
const serializeAws_json1_0TagKeyList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_json1_0TagList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0Tag(entry, context);
    });
};
const serializeAws_json1_0TagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceARN !== undefined && input.ResourceARN !== null && { ResourceARN: input.ResourceARN }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_0TagList(input.Tags, context) }),
    };
};
const serializeAws_json1_0TargetConfiguration = (input, context) => {
    return {
        ...(input.TimestreamConfiguration !== undefined &&
            input.TimestreamConfiguration !== null && {
            TimestreamConfiguration: serializeAws_json1_0TimestreamConfiguration(input.TimestreamConfiguration, context),
        }),
    };
};
const serializeAws_json1_0TimestreamConfiguration = (input, context) => {
    return {
        ...(input.DatabaseName !== undefined && input.DatabaseName !== null && { DatabaseName: input.DatabaseName }),
        ...(input.DimensionMappings !== undefined &&
            input.DimensionMappings !== null && {
            DimensionMappings: serializeAws_json1_0DimensionMappingList(input.DimensionMappings, context),
        }),
        ...(input.MeasureNameColumn !== undefined &&
            input.MeasureNameColumn !== null && { MeasureNameColumn: input.MeasureNameColumn }),
        ...(input.MixedMeasureMappings !== undefined &&
            input.MixedMeasureMappings !== null && {
            MixedMeasureMappings: serializeAws_json1_0MixedMeasureMappingList(input.MixedMeasureMappings, context),
        }),
        ...(input.MultiMeasureMappings !== undefined &&
            input.MultiMeasureMappings !== null && {
            MultiMeasureMappings: serializeAws_json1_0MultiMeasureMappings(input.MultiMeasureMappings, context),
        }),
        ...(input.TableName !== undefined && input.TableName !== null && { TableName: input.TableName }),
        ...(input.TimeColumn !== undefined && input.TimeColumn !== null && { TimeColumn: input.TimeColumn }),
    };
};
const serializeAws_json1_0UntagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceARN !== undefined && input.ResourceARN !== null && { ResourceARN: input.ResourceARN }),
        ...(input.TagKeys !== undefined &&
            input.TagKeys !== null && { TagKeys: serializeAws_json1_0TagKeyList(input.TagKeys, context) }),
    };
};
const serializeAws_json1_0UpdateScheduledQueryRequest = (input, context) => {
    return {
        ...(input.ScheduledQueryArn !== undefined &&
            input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn }),
        ...(input.State !== undefined && input.State !== null && { State: input.State }),
    };
};
const deserializeAws_json1_0AccessDeniedException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeAws_json1_0CancelQueryResponse = (output, context) => {
    return {
        CancellationMessage: (0, smithy_client_1.expectString)(output.CancellationMessage),
    };
};
const deserializeAws_json1_0ColumnInfo = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Type: output.Type !== undefined && output.Type !== null ? deserializeAws_json1_0Type(output.Type, context) : undefined,
    };
};
const deserializeAws_json1_0ColumnInfoList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ColumnInfo(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0ConflictException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeAws_json1_0CreateScheduledQueryResponse = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
    };
};
const deserializeAws_json1_0Datum = (output, context) => {
    return {
        ArrayValue: output.ArrayValue !== undefined && output.ArrayValue !== null
            ? deserializeAws_json1_0DatumList(output.ArrayValue, context)
            : undefined,
        NullValue: (0, smithy_client_1.expectBoolean)(output.NullValue),
        RowValue: output.RowValue !== undefined && output.RowValue !== null
            ? deserializeAws_json1_0Row(output.RowValue, context)
            : undefined,
        ScalarValue: (0, smithy_client_1.expectString)(output.ScalarValue),
        TimeSeriesValue: output.TimeSeriesValue !== undefined && output.TimeSeriesValue !== null
            ? deserializeAws_json1_0TimeSeriesDataPointList(output.TimeSeriesValue, context)
            : undefined,
    };
};
const deserializeAws_json1_0DatumList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Datum(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0DescribeEndpointsResponse = (output, context) => {
    return {
        Endpoints: output.Endpoints !== undefined && output.Endpoints !== null
            ? deserializeAws_json1_0Endpoints(output.Endpoints, context)
            : undefined,
    };
};
const deserializeAws_json1_0DescribeScheduledQueryResponse = (output, context) => {
    return {
        ScheduledQuery: output.ScheduledQuery !== undefined && output.ScheduledQuery !== null
            ? deserializeAws_json1_0ScheduledQueryDescription(output.ScheduledQuery, context)
            : undefined,
    };
};
const deserializeAws_json1_0DimensionMapping = (output, context) => {
    return {
        DimensionValueType: (0, smithy_client_1.expectString)(output.DimensionValueType),
        Name: (0, smithy_client_1.expectString)(output.Name),
    };
};
const deserializeAws_json1_0DimensionMappingList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0DimensionMapping(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0Endpoint = (output, context) => {
    return {
        Address: (0, smithy_client_1.expectString)(output.Address),
        CachePeriodInMinutes: (0, smithy_client_1.expectLong)(output.CachePeriodInMinutes),
    };
};
const deserializeAws_json1_0Endpoints = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Endpoint(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0ErrorReportConfiguration = (output, context) => {
    return {
        S3Configuration: output.S3Configuration !== undefined && output.S3Configuration !== null
            ? deserializeAws_json1_0S3Configuration(output.S3Configuration, context)
            : undefined,
    };
};
const deserializeAws_json1_0ErrorReportLocation = (output, context) => {
    return {
        S3ReportLocation: output.S3ReportLocation !== undefined && output.S3ReportLocation !== null
            ? deserializeAws_json1_0S3ReportLocation(output.S3ReportLocation, context)
            : undefined,
    };
};
const deserializeAws_json1_0ExecutionStats = (output, context) => {
    return {
        BytesMetered: (0, smithy_client_1.expectLong)(output.BytesMetered),
        DataWrites: (0, smithy_client_1.expectLong)(output.DataWrites),
        ExecutionTimeInMillis: (0, smithy_client_1.expectLong)(output.ExecutionTimeInMillis),
        QueryResultRows: (0, smithy_client_1.expectLong)(output.QueryResultRows),
        RecordsIngested: (0, smithy_client_1.expectLong)(output.RecordsIngested),
    };
};
const deserializeAws_json1_0InternalServerException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeAws_json1_0InvalidEndpointException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeAws_json1_0ListScheduledQueriesResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        ScheduledQueries: output.ScheduledQueries !== undefined && output.ScheduledQueries !== null
            ? deserializeAws_json1_0ScheduledQueryList(output.ScheduledQueries, context)
            : undefined,
    };
};
const deserializeAws_json1_0ListTagsForResourceResponse = (output, context) => {
    return {
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_json1_0TagList(output.Tags, context)
            : undefined,
    };
};
const deserializeAws_json1_0MixedMeasureMapping = (output, context) => {
    return {
        MeasureName: (0, smithy_client_1.expectString)(output.MeasureName),
        MeasureValueType: (0, smithy_client_1.expectString)(output.MeasureValueType),
        MultiMeasureAttributeMappings: output.MultiMeasureAttributeMappings !== undefined && output.MultiMeasureAttributeMappings !== null
            ? deserializeAws_json1_0MultiMeasureAttributeMappingList(output.MultiMeasureAttributeMappings, context)
            : undefined,
        SourceColumn: (0, smithy_client_1.expectString)(output.SourceColumn),
        TargetMeasureName: (0, smithy_client_1.expectString)(output.TargetMeasureName),
    };
};
const deserializeAws_json1_0MixedMeasureMappingList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0MixedMeasureMapping(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0MultiMeasureAttributeMapping = (output, context) => {
    return {
        MeasureValueType: (0, smithy_client_1.expectString)(output.MeasureValueType),
        SourceColumn: (0, smithy_client_1.expectString)(output.SourceColumn),
        TargetMultiMeasureAttributeName: (0, smithy_client_1.expectString)(output.TargetMultiMeasureAttributeName),
    };
};
const deserializeAws_json1_0MultiMeasureAttributeMappingList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0MultiMeasureAttributeMapping(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0MultiMeasureMappings = (output, context) => {
    return {
        MultiMeasureAttributeMappings: output.MultiMeasureAttributeMappings !== undefined && output.MultiMeasureAttributeMappings !== null
            ? deserializeAws_json1_0MultiMeasureAttributeMappingList(output.MultiMeasureAttributeMappings, context)
            : undefined,
        TargetMultiMeasureName: (0, smithy_client_1.expectString)(output.TargetMultiMeasureName),
    };
};
const deserializeAws_json1_0NotificationConfiguration = (output, context) => {
    return {
        SnsConfiguration: output.SnsConfiguration !== undefined && output.SnsConfiguration !== null
            ? deserializeAws_json1_0SnsConfiguration(output.SnsConfiguration, context)
            : undefined,
    };
};
const deserializeAws_json1_0ParameterMapping = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Type: output.Type !== undefined && output.Type !== null ? deserializeAws_json1_0Type(output.Type, context) : undefined,
    };
};
const deserializeAws_json1_0ParameterMappingList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ParameterMapping(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0PrepareQueryResponse = (output, context) => {
    return {
        Columns: output.Columns !== undefined && output.Columns !== null
            ? deserializeAws_json1_0SelectColumnList(output.Columns, context)
            : undefined,
        Parameters: output.Parameters !== undefined && output.Parameters !== null
            ? deserializeAws_json1_0ParameterMappingList(output.Parameters, context)
            : undefined,
        QueryString: (0, smithy_client_1.expectString)(output.QueryString),
    };
};
const deserializeAws_json1_0QueryExecutionException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeAws_json1_0QueryResponse = (output, context) => {
    return {
        ColumnInfo: output.ColumnInfo !== undefined && output.ColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfoList(output.ColumnInfo, context)
            : undefined,
        NextToken: (0, smithy_client_1.expectString)(output.NextToken),
        QueryId: (0, smithy_client_1.expectString)(output.QueryId),
        QueryStatus: output.QueryStatus !== undefined && output.QueryStatus !== null
            ? deserializeAws_json1_0QueryStatus(output.QueryStatus, context)
            : undefined,
        Rows: output.Rows !== undefined && output.Rows !== null
            ? deserializeAws_json1_0RowList(output.Rows, context)
            : undefined,
    };
};
const deserializeAws_json1_0QueryStatus = (output, context) => {
    return {
        CumulativeBytesMetered: (0, smithy_client_1.expectLong)(output.CumulativeBytesMetered),
        CumulativeBytesScanned: (0, smithy_client_1.expectLong)(output.CumulativeBytesScanned),
        ProgressPercentage: (0, smithy_client_1.limitedParseDouble)(output.ProgressPercentage),
    };
};
const deserializeAws_json1_0ResourceNotFoundException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
        ScheduledQueryArn: (0, smithy_client_1.expectString)(output.ScheduledQueryArn),
    };
};
const deserializeAws_json1_0Row = (output, context) => {
    return {
        Data: output.Data !== undefined && output.Data !== null
            ? deserializeAws_json1_0DatumList(output.Data, context)
            : undefined,
    };
};
const deserializeAws_json1_0RowList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Row(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0S3Configuration = (output, context) => {
    return {
        BucketName: (0, smithy_client_1.expectString)(output.BucketName),
        EncryptionOption: (0, smithy_client_1.expectString)(output.EncryptionOption),
        ObjectKeyPrefix: (0, smithy_client_1.expectString)(output.ObjectKeyPrefix),
    };
};
const deserializeAws_json1_0S3ReportLocation = (output, context) => {
    return {
        BucketName: (0, smithy_client_1.expectString)(output.BucketName),
        ObjectKey: (0, smithy_client_1.expectString)(output.ObjectKey),
    };
};
const deserializeAws_json1_0ScheduleConfiguration = (output, context) => {
    return {
        ScheduleExpression: (0, smithy_client_1.expectString)(output.ScheduleExpression),
    };
};
const deserializeAws_json1_0ScheduledQuery = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreationTime)))
            : undefined,
        ErrorReportConfiguration: output.ErrorReportConfiguration !== undefined && output.ErrorReportConfiguration !== null
            ? deserializeAws_json1_0ErrorReportConfiguration(output.ErrorReportConfiguration, context)
            : undefined,
        LastRunStatus: (0, smithy_client_1.expectString)(output.LastRunStatus),
        Name: (0, smithy_client_1.expectString)(output.Name),
        NextInvocationTime: output.NextInvocationTime !== undefined && output.NextInvocationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.NextInvocationTime)))
            : undefined,
        PreviousInvocationTime: output.PreviousInvocationTime !== undefined && output.PreviousInvocationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.PreviousInvocationTime)))
            : undefined,
        State: (0, smithy_client_1.expectString)(output.State),
        TargetDestination: output.TargetDestination !== undefined && output.TargetDestination !== null
            ? deserializeAws_json1_0TargetDestination(output.TargetDestination, context)
            : undefined,
    };
};
const deserializeAws_json1_0ScheduledQueryDescription = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreationTime)))
            : undefined,
        ErrorReportConfiguration: output.ErrorReportConfiguration !== undefined && output.ErrorReportConfiguration !== null
            ? deserializeAws_json1_0ErrorReportConfiguration(output.ErrorReportConfiguration, context)
            : undefined,
        KmsKeyId: (0, smithy_client_1.expectString)(output.KmsKeyId),
        LastRunSummary: output.LastRunSummary !== undefined && output.LastRunSummary !== null
            ? deserializeAws_json1_0ScheduledQueryRunSummary(output.LastRunSummary, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        NextInvocationTime: output.NextInvocationTime !== undefined && output.NextInvocationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.NextInvocationTime)))
            : undefined,
        NotificationConfiguration: output.NotificationConfiguration !== undefined && output.NotificationConfiguration !== null
            ? deserializeAws_json1_0NotificationConfiguration(output.NotificationConfiguration, context)
            : undefined,
        PreviousInvocationTime: output.PreviousInvocationTime !== undefined && output.PreviousInvocationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.PreviousInvocationTime)))
            : undefined,
        QueryString: (0, smithy_client_1.expectString)(output.QueryString),
        RecentlyFailedRuns: output.RecentlyFailedRuns !== undefined && output.RecentlyFailedRuns !== null
            ? deserializeAws_json1_0ScheduledQueryRunSummaryList(output.RecentlyFailedRuns, context)
            : undefined,
        ScheduleConfiguration: output.ScheduleConfiguration !== undefined && output.ScheduleConfiguration !== null
            ? deserializeAws_json1_0ScheduleConfiguration(output.ScheduleConfiguration, context)
            : undefined,
        ScheduledQueryExecutionRoleArn: (0, smithy_client_1.expectString)(output.ScheduledQueryExecutionRoleArn),
        State: (0, smithy_client_1.expectString)(output.State),
        TargetConfiguration: output.TargetConfiguration !== undefined && output.TargetConfiguration !== null
            ? deserializeAws_json1_0TargetConfiguration(output.TargetConfiguration, context)
            : undefined,
    };
};
const deserializeAws_json1_0ScheduledQueryList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ScheduledQuery(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0ScheduledQueryRunSummary = (output, context) => {
    return {
        ErrorReportLocation: output.ErrorReportLocation !== undefined && output.ErrorReportLocation !== null
            ? deserializeAws_json1_0ErrorReportLocation(output.ErrorReportLocation, context)
            : undefined,
        ExecutionStats: output.ExecutionStats !== undefined && output.ExecutionStats !== null
            ? deserializeAws_json1_0ExecutionStats(output.ExecutionStats, context)
            : undefined,
        FailureReason: (0, smithy_client_1.expectString)(output.FailureReason),
        InvocationTime: output.InvocationTime !== undefined && output.InvocationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.InvocationTime)))
            : undefined,
        RunStatus: (0, smithy_client_1.expectString)(output.RunStatus),
        TriggerTime: output.TriggerTime !== undefined && output.TriggerTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.TriggerTime)))
            : undefined,
    };
};
const deserializeAws_json1_0ScheduledQueryRunSummaryList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ScheduledQueryRunSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0SelectColumn = (output, context) => {
    return {
        Aliased: (0, smithy_client_1.expectBoolean)(output.Aliased),
        DatabaseName: (0, smithy_client_1.expectString)(output.DatabaseName),
        Name: (0, smithy_client_1.expectString)(output.Name),
        TableName: (0, smithy_client_1.expectString)(output.TableName),
        Type: output.Type !== undefined && output.Type !== null ? deserializeAws_json1_0Type(output.Type, context) : undefined,
    };
};
const deserializeAws_json1_0SelectColumnList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0SelectColumn(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0ServiceQuotaExceededException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeAws_json1_0SnsConfiguration = (output, context) => {
    return {
        TopicArn: (0, smithy_client_1.expectString)(output.TopicArn),
    };
};
const deserializeAws_json1_0Tag = (output, context) => {
    return {
        Key: (0, smithy_client_1.expectString)(output.Key),
        Value: (0, smithy_client_1.expectString)(output.Value),
    };
};
const deserializeAws_json1_0TagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Tag(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0TagResourceResponse = (output, context) => {
    return {};
};
const deserializeAws_json1_0TargetConfiguration = (output, context) => {
    return {
        TimestreamConfiguration: output.TimestreamConfiguration !== undefined && output.TimestreamConfiguration !== null
            ? deserializeAws_json1_0TimestreamConfiguration(output.TimestreamConfiguration, context)
            : undefined,
    };
};
const deserializeAws_json1_0TargetDestination = (output, context) => {
    return {
        TimestreamDestination: output.TimestreamDestination !== undefined && output.TimestreamDestination !== null
            ? deserializeAws_json1_0TimestreamDestination(output.TimestreamDestination, context)
            : undefined,
    };
};
const deserializeAws_json1_0ThrottlingException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeAws_json1_0TimeSeriesDataPoint = (output, context) => {
    return {
        Time: (0, smithy_client_1.expectString)(output.Time),
        Value: output.Value !== undefined && output.Value !== null
            ? deserializeAws_json1_0Datum(output.Value, context)
            : undefined,
    };
};
const deserializeAws_json1_0TimeSeriesDataPointList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0TimeSeriesDataPoint(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_0TimestreamConfiguration = (output, context) => {
    return {
        DatabaseName: (0, smithy_client_1.expectString)(output.DatabaseName),
        DimensionMappings: output.DimensionMappings !== undefined && output.DimensionMappings !== null
            ? deserializeAws_json1_0DimensionMappingList(output.DimensionMappings, context)
            : undefined,
        MeasureNameColumn: (0, smithy_client_1.expectString)(output.MeasureNameColumn),
        MixedMeasureMappings: output.MixedMeasureMappings !== undefined && output.MixedMeasureMappings !== null
            ? deserializeAws_json1_0MixedMeasureMappingList(output.MixedMeasureMappings, context)
            : undefined,
        MultiMeasureMappings: output.MultiMeasureMappings !== undefined && output.MultiMeasureMappings !== null
            ? deserializeAws_json1_0MultiMeasureMappings(output.MultiMeasureMappings, context)
            : undefined,
        TableName: (0, smithy_client_1.expectString)(output.TableName),
        TimeColumn: (0, smithy_client_1.expectString)(output.TimeColumn),
    };
};
const deserializeAws_json1_0TimestreamDestination = (output, context) => {
    return {
        DatabaseName: (0, smithy_client_1.expectString)(output.DatabaseName),
        TableName: (0, smithy_client_1.expectString)(output.TableName),
    };
};
const deserializeAws_json1_0Type = (output, context) => {
    return {
        ArrayColumnInfo: output.ArrayColumnInfo !== undefined && output.ArrayColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfo(output.ArrayColumnInfo, context)
            : undefined,
        RowColumnInfo: output.RowColumnInfo !== undefined && output.RowColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfoList(output.RowColumnInfo, context)
            : undefined,
        ScalarType: (0, smithy_client_1.expectString)(output.ScalarType),
        TimeSeriesMeasureValueColumnInfo: output.TimeSeriesMeasureValueColumnInfo !== undefined && output.TimeSeriesMeasureValueColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfo(output.TimeSeriesMeasureValueColumnInfo, context)
            : undefined,
    };
};
const deserializeAws_json1_0UntagResourceResponse = (output, context) => {
    return {};
};
const deserializeAws_json1_0ValidationException = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
    };
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const buildHttpRpcRequest = async (context, headers, path, resolvedHostname, body) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const contents = {
        protocol,
        hostname,
        port,
        method: "POST",
        path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
        headers,
    };
    if (resolvedHostname !== undefined) {
        contents.hostname = resolvedHostname;
    }
    if (body !== undefined) {
        contents.body = body;
    }
    return new protocol_http_1.HttpRequest(contents);
};
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
