import { Logger as __Logger } from "@aws-sdk/types";
import { TimestreamQueryClientConfig } from "./TimestreamQueryClient";

export declare const getRuntimeConfig: (config: TimestreamQueryClientConfig) => {
    apiVersion: string;
    disableHostPrefix: boolean;
    logger: __Logger;
    regionInfoProvider: import("@aws-sdk/types").RegionInfoProvider;
    serviceId: string;
    urlParser: import("@aws-sdk/types").UrlParser;
};
